using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace EmployeeManager
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox listBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components=null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			Employee Britney = new Employee("Britney Spears", 20000.00M);
			Employee Elton = new Manager("Elton John", 50000.00M);
			Manager Ginger = new Manager("Geri Halliwell", 50000.00M, 20000.00M);

			Employee [] Employees = new  Employee[3];
			Employees[0] = Britney;
			Employees[1] = Elton;
			Employees[2] = Ginger;

			for (int I=0 ; I<3 ; I++)
			{
				this.listBox1.Items.Add(Employees[I].Name);
				this.listBox1.Items.Add(Employees[I].ToString());
				this.listBox1.Items.Add("");
			}

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(8, 8);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(400, 238);
			this.listBox1.TabIndex = 0;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 269);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {this.listBox1});
			this.Name = "MainForm";
			this.Text = "EmployeeManager C# Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}
	}



	class Employee
	{
		private readonly string name;
		private decimal salary;
		private static readonly string companyName;

		public Employee(string name, decimal salary)
		{
			this.name = name;
			this.salary = salary;
		}

		static Employee()
		{
			companyName = "Wrox Press Pop Stars";
		}

		public string Name
		{
			get
			{
				return name;
			}
		}




		public virtual decimal Salary
		{
			get
			{
				return salary;
			}
			set
			{
				salary = value;
			}
		}

		public virtual decimal GetMonthlyPayment()
		{
			return salary/12;
		}

		public static string CompanyName
		{
			get
			{
				return companyName;
			}
		}

		public override string ToString()
		{
			return "Name: " + name + ", Salary: $" + salary;
		}
	}


	class Manager : Employee
	{
		private decimal bonus;

		public Manager(string name, decimal salary, decimal bonus)
			:	base(name, salary)
		{
			this.bonus = bonus;
		}

		public Manager(string name, decimal salary)
			:	this(name, salary, 100000M)
		{
		}

		public decimal Bonus
		{
			get
			{
				return bonus;
			}
		}

		public override string ToString()
		{
			return base.ToString() + ", bonus: $" + bonus;
		}

		public override decimal GetMonthlyPayment()
		{
			return base.GetMonthlyPayment() + bonus/12;
		}
	}
}
