using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Wrox.ProCSharp.VbToCSharp.SquareRootSample
{

	/// <summary>
	/// The Form that forms the main window for the app.
	/// </summary>

	public class SquareRootForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtNumber;
		private System.Windows.Forms.TextBox txtSign;
		private System.Windows.Forms.TextBox txtResult;
		private System.Windows.Forms.Button cmdShowResults;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components=null;
		public SquareRootForm()
		{
			InitializeComponent();
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

      #region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support  do not modify
		/// the contents of this method with the code editor.
		/// </summary>

		private void InitializeComponent()
		{
			this.txtNumber = new System.Windows.Forms.TextBox();
			this.txtSign = new System.Windows.Forms.TextBox();
			this.cmdShowResults = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.txtResult = new System.Windows.Forms.TextBox();
			this.SuspendLayout();

			//
			// txtNumber
			//

			this.txtNumber.Location = new System.Drawing.Point(160, 24);
			this.txtNumber.Name = "txtNumber";
			this.txtNumber.TabIndex = 0;
			this.txtNumber.Text = "";

			//
			// txtSign
			//

			this.txtSign.Enabled = false;
			this.txtSign.Location = new System.Drawing.Point(160, 136);
			this.txtSign.Name = "txtSign";
			this.txtSign.TabIndex = 1;
			this.txtSign.Text = "";

			//
			// cmdShowResults
			//

			this.cmdShowResults.Location = new System.Drawing.Point(24, 96);
			this.cmdShowResults.Name = "cmdShowResults";
			this.cmdShowResults.Size = new System.Drawing.Size(88, 23);
			this.cmdShowResults.TabIndex = 3;
			this.cmdShowResults.Text = "Show Results";
			this.cmdShowResults.Click += new
				System.EventHandler(this.OnClickShowResults);

			//
			// label3
			//

			this.label3.Location = new System.Drawing.Point(72, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 23);
			this.label3.TabIndex = 6;
			this.label3.Text = "Input a number";

			//
			// label4
			//

			this.label4.Location = new System.Drawing.Point(80, 184);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 16);
			this.label4.TabIndex = 7;
			this.label4.Text = "Square root is";

			//
			// label1
			//

			this.label1.Location = new System.Drawing.Point(112, 136);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 23);
			this.label1.TabIndex = 4;
			this.label1.Text = "Sign is";

			//
			// label2
			//

			this.label2.Location = new System.Drawing.Point(48, 184);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(8, 8);
			this.label2.TabIndex = 5;

			//
			// txtResult
			//

			this.txtResult.Enabled = false;
			this.txtResult.Location = new System.Drawing.Point(160, 184);
			this.txtResult.Name = "txtResult";
			this.txtResult.TabIndex = 2;
			this.txtResult.Text = "";

			//
			// Form1
			//

			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 269);
			this.Controls.AddRange(new System.Windows.Forms.Control[]
								   {
										   this.label4,
									   this.label3,
									   this.label2,
									   this.label1,
									   this.cmdShowResults,
									   this.txtResult,
									   this.txtSign,
									   this.txtNumber});
			this.Name = "Form1";
			this.Text = "Square Root C# Sample";
			this.ResumeLayout(false);
		}

      #endregion

		/// <summary>
		/// Event handler for user clicking Show Results button.
		/// Displays square root and sign of number
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>

		private void OnClickShowResults(object sender, System.EventArgs e)
		{
			float NumberInput = float.Parse(this.txtNumber.Text);
			if (NumberInput < 0)
			{
				this.txtSign.Text = "Negative";
				this.txtResult.Text = Math.Sqrt(-NumberInput) + " I";
			}
			else if (NumberInput == 0)
			{
				txtSign.Text = "Zero";
				txtResult.Text = "0";
			}
			else
			{
				this.txtSign.Text = "Positive";
				this.txtResult.Text = Math.Sqrt(NumberInput).ToString();
			}
		}
	}
	class MainEntryClass
	{

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		[STAThread]
		static void Main()
		{
			SquareRootForm TheMainForm = new SquareRootForm();
			Application.Run(TheMainForm);
		}
	}
}

